<template>
    <Head><title>Характеристики товаров</title></Head>
    <div>
        <div class="g-titlebar">
            <h1>Характеристики</h1>
        </div>
        <template v-if="productType">
            <b-filter
                v-model="filter"
                :fields="{
                    q: {
                        type: 'text',
                        placeholder: 'Поиск по названию / URL',
                    },
                    pricelist: {
                        type: 'checkbox',
                        text: 'Есть в прайсах',
                    },
                    model: {
                        type: 'checkbox',
                        text: 'Характеристика модели',
                    },
                    filter: {
                        type: 'checkbox',
                        text: 'Есть в фильтрах',
                    },
                }"
            />
            <table class="g-table style_props" :class="{ loading: filter.loading }">
                <thead>
                    <tr>
                        <td class="has_icon_offset">Название</td>
                        <td>URL</td>
                        <td>
                            <font-awesome-icon icon="file-export" title="Можно получить из прайс-листа" />
                        </td>
                        <td>
                            <font-awesome-icon
                                icon="box"
                                title="Характеристика модели: значение одинаковое для всех предложений в рамках одной модели"
                            />
                        </td>
                        <td>
                            <font-awesome-icon icon="filter" title="Есть фильтр по характеристике" />
                        </td>
                        <td></td>
                    </tr>
                </thead>
                <tbody>
                    <template v-for="prop in productProps" :key="prop.id">
                        <tr class="type_prop">
                            <td class="nowrap icon_offset">
                                <a class="g-table-expander" @click.prevent="toggleValues(prop.id)">
                                    <font-awesome-icon
                                        :icon="'fa-regular fa-square-caret-' + (showValues[prop.id] ? 'up' : 'down')"
                                    />
                                    {{ prop.title }} ({{ Array.isArray(prop.values) ? prop.values.length : 0 }})
                                </a>
                            </td>
                            <td class="nowrap">{{ prop.slug }}</td>
                            <td>
                                <font-awesome-icon icon="fa-solid fa-check" v-if="prop.is_pricelist_prop" />
                            </td>
                            <td>
                                <font-awesome-icon icon="fa-solid fa-check" v-if="prop.is_model_prop" />
                            </td>
                            <td>
                                <font-awesome-icon icon="fa-solid fa-check" v-if="prop.is_filter_prop" />
                            </td>
                            <td class="nowrap right">
                                <a @click="deleteProductProp(prop.id, prop.title)" title="Удалить" class="g-actionicon">
                                    <font-awesome-icon icon="trash" />
                                </a>
                                <Link
                                    :href="`/product_props/${prop.id}/edit/`"
                                    title="Редактировать"
                                    class="g-actionicon"
                                >
                                    <font-awesome-icon icon="pen-to-square" />
                                </Link>
                            </td>
                        </tr>
                        <template v-if="showValues[prop.id]">
                            <tr v-for="propValue in prop.values" class="type_value" :key="propValue.id">
                                <td class="icon_offset">
                                    {{ propValue.title !== null ? propValue.title : propValue.value }}
                                </td>
                                <td>{{ propValue.value }}</td>
                                <td></td>
                                <td></td>
                                <td>
                                    <font-awesome-icon icon="fa-solid fa-check" v-if="propValue.is_visible" />
                                </td>
                                <td class="nowrap right">
                                    <a
                                        @click="deletePropValue(propValue.id, propValue.title)"
                                        title="Удалить"
                                        class="g-actionicon"
                                    >
                                        <font-awesome-icon icon="trash" />
                                    </a>
                                    <a
                                        @click="showPropValueForm(prop.id, propValue.id)"
                                        title="Редактировать"
                                        class="g-actionicon"
                                    >
                                        <font-awesome-icon icon="pen-to-square" />
                                    </a>
                                </td>
                            </tr>
                            <tr class="type_addvalue">
                                <td colspan="9" class="icon_offset">
                                    <a @click.prevent="showPropValueForm(prop.id)">
                                        <font-awesome-icon icon="plus" />
                                        Добавить значение
                                    </a>
                                </td>
                            </tr>
                        </template>
                    </template>
                </tbody>
            </table>
            <Link :href="`/product_types/${productType}/product_props/create/`" class="g-button outlined">
                Создать характеристику
            </Link>
        </template>
        <template v-else>
            <p>Выберите тип товара для просмотра и редактирования характеристик</p>
        </template>
        <el-dialog v-model="valueForm.isShown" :title="propValueDialogTitle" width="650px" draggable append-to-body>
            <form
                class="b-form for_propvalue"
                :class="{ loading: valueForm.processing }"
                @submit.prevent="submitPropValueForm"
            >
                <b-formrow
                    title="Значение"
                    hint="Может содержать английские буквы, цифры и нижнее подчеркивание"
                    :error="propValueErrors.value"
                    class="type_text"
                >
                    <el-input type="text" v-model="valueForm.values.value" />
                </b-formrow>
                <b-formrow title="Отображать как" :error="propValueErrors.title" class="type_text">
                    <el-input type="text" v-model="valueForm.values.title" />
                </b-formrow>
                <b-formrow title="Синонимы в прайс-листах" :error="propValueErrors.synonyms" class="type_list">
                    <el-select
                        v-model="valueForm.values.synonyms"
                        multiple
                        filterable
                        allow-create
                        default-first-option
                        :reserve-keyword="false"
                        placeholder="Начните вводить и нажмите Enter"
                    />
                </b-formrow>
                <button class="g-button">{{ propValueDialogButton }}</button>
                <button class="g-button outlined" @click.prevent="valueForm.isShown = false">Вернуться назад</button>
            </form>
        </el-dialog>
    </div>
</template>

<script>
import { router } from "@inertiajs/vue3";
import { initial } from "lodash-es";
export default {
    props: {
        productType: String,
        productProps: Object,
        initialFilter: Object,
        errors: Object,
    },
    data() {
        return {
            filter: { ...this.initialFilter, loading: false },
            // Показывать (раскрыть) значения в таблице: propId => (bool)
            showValues: {},
            //
            valueForm: {
                isShown: false,
                activePropId: null,
                activePropTitle: null,
                activeValueId: null,
                values: {},
            },
            propsErrors: this.errors,
        };
    },
    computed: {
        propValueDialogTitle() {
            return (
                this.valueForm.activePropTitle +
                ": " +
                (this.valueForm.activeValueId ? "Редактирование значения" : "Добавление значения")
            );
        },
        propValueDialogButton() {
            return this.valueForm.activeValueId ? "Сохранить изменения" : "Добавить значение";
        },
        propValueErrors() {
            return this.propsErrors.propValue ? this.propsErrors.propValue : {};
        },
    },
    methods: {
        initial,
        toggleValues(propId) {
            this.showValues[propId] = !this.showValues[propId];
        },
        switchProductType(newProductType) {
            router.get(`/product_types/${newProductType}/product_props/`);
        },
        getPropById(propId) {
            for (let prop of this.productProps) {
                if (prop.id === propId) return prop;
            }
            return null;
        },
        getValueById(valueId) {
            for (let prop of this.productProps) {
                for (let value of prop.values) {
                    if (value.id === valueId) return value;
                }
            }
            return null;
        },
        showPropValueForm(propId, valueId) {
            const prop = this.getPropById(propId);
            if (prop === null) return;
            this.propsErrors.propValue = {};
            this.valueForm.activePropId = propId;
            this.valueForm.activePropTitle = prop.title;
            this.valueForm.activeValueId = valueId ?? null;
            this.valueForm.errors = {};
            if (valueId === undefined) {
                // Добавление нового значения
                this.valueForm.values = {};
            } else {
                // Редактирование существующего значения
                const value = this.getValueById(valueId);
                if (value === null) return;
                this.valueForm.values = { ...value };
            }
            this.valueForm.isShown = true;
        },
        async submitPropValueForm() {
            // this.valueForm.processing = true;
            const url =
                "/product_prop_values" + (this.valueForm.activeValueId ? "/" + this.valueForm.activeValueId : "");
            router.visit(url, {
                method: this.valueForm.activeValueId ? "PUT" : "POST",
                data: {
                    product_prop_id: this.valueForm.activePropId,
                    ...this.valueForm.values,
                },
                errorBag: "propValue",
                replace: true,
                preserveState: true,
                onFinish: function () {
                    this.valueForm.processing = false;
                    if (this.valueForm.activeValueId) {
                        // При успешном сохранении изменений закрываем форму
                        this.valueForm.isShown = false;
                    } else {
                        // При успешном добавлении очищаем значения
                        this.valueForm.values = {};
                    }
                }.bind(this),
            });
        },
        deleteProductProp(id, title) {
            if (!confirm(`Вы действительно хотите удалить характеристику товара «${title}»?`)) return;
            router.delete(`/product_props/${id}/`);
        },
        deletePropValue(id, title) {
            if (!confirm(`Вы действительно хотите удалить значение характеристики «${title}»?`)) return;
            router.delete(`/product_prop_values/${id}/`);
        },
    },
};
</script>

<style lang="scss">
.g-table.style_props {
    border-bottom: 1px var(--border) solid;
    tr.type_prop {
        td {
            border-top: 1px var(--border) solid;
            border-bottom: 0;
        }
    }
    tr.type_value {
        &:hover {
            background-color: var(--primary-lightest);
        }
        td {
            border-bottom: 0;
            padding-top: 0.4rem;
            padding-bottom: 0.4rem;
            .g-actionicon {
                font-size: 12px;
            }
        }
    }
    tr.type_addvalue {
        td {
            padding-top: 0.4rem;
            padding-bottom: 1rem;
            a {
                cursor: pointer;
            }
        }
    }
    td.icon_offset {
        padding-left: 20px;
    }
    .g-table-expander {
        position: relative;
        display: block;
        color: var(--primary);
        cursor: pointer;
        left: -20px;
        padding-left: 20px;
        svg {
            position: absolute;
            left: 0;
            top: 3px;
        }
        &:hover {
            color: var(--primary-dark);
        }
    }
}
.b-form.for_propvalue {
    .b-formrow-title {
        width: 220px;
    }
    .b-formrow-input {
        width: 400px;
    }
}
</style>
